#line 1 "\ibmcpp\include\string.h"
#pragma info( none )

   #pragma info( none )

#pragma info( restore )
#line 11
      extern "C" {
#line 14
   /********************************************************************/
   /*  <string.h> header file                                          */
   /*                                                                  */
   /*  Licensed Materials - Property of IBM                            */
   /*                                                                  */
   /*  IBM C/C++ Tools Version 2.01                                    */
   /*  Copyright (C) International Business Machines Corp., 1991,1993  */
   /*  All rights reserved                                             */
   /*                                                                  */
   /*  US Government Users Restricted Rights -                         */
   /*  Use, duplication, or disclosure restricted                      */
   /*  by GSA ADP Schedule Contract with IBM Corp.                     */
   /*                                                                  */
   /********************************************************************/
#line 31
      typedef unsigned int size_t;
#line 42
   char * _Builtin __strcat( char *, const char * );
   char * _Builtin __strchr( const char *, int );
   int    _Builtin __strcmp( const char *, const char * );
   char * _Builtin __strcpy( char*, const char * );
   size_t _Builtin __strlen( const char * );
   char * _Builtin __strncat( char *, const char *, size_t );
   int    _Builtin __strncmp( const char *, const char *, size_t );
   char * _Builtin __strncpy( char *, const char *, size_t );
   char * _Builtin __strrchr( const char *, int );
   char * _Optlink strcat( char *, const char * );
   char * _Optlink strchr( const char *, int );
   int    _Optlink strcmp( const char *, const char * );
   char * _Optlink strcpy( char *, const char * );
   size_t _Optlink strlen( const char * );
   char * _Optlink strncat( char *, const char *, size_t );
   int    _Optlink strncmp( const char *, const char *, size_t );
   char * _Optlink strncpy( char *, const char *, size_t );
   char * _Optlink strrchr( const char *, int );
   int    _Optlink strcoll( const char *, const char * );
   size_t _Optlink strcspn( const char *, const char * );
   char * _Optlink strerror( int );
   char * _Optlink strpbrk( const char *, const char * );
   size_t _Optlink strspn( const char *, const char * );
   char * _Optlink strstr( const char *, const char * );
   char * _Optlink strtok( char*, const char * );
   size_t _Optlink strxfrm( char *, const char *, size_t );
#line 70
      inline char * strcat( char * s1, const char * s2 )
                     { return __strcat( s1, s2 ); }
      inline char * strchr( const char * s, int ch )
                     { return __strchr( s, ch ); }
      inline int    strcmp( const char * s1, const char * s2 )
                     { return __strcmp( s1, s2 ); }
      inline char * strcpy( char * s1, const char * s2 )
                     { return __strcpy( s1, s2 ); }
      inline size_t strlen( const char * s )
                     { return __strlen( s ); }
      inline char * strncat( char * s1, const char * s2, size_t len )
                     { return __strncat( s1, s2, len ); }
      inline int    strncmp( const char * s1, const char * s2, size_t len )
                     { return __strncmp( s1, s2, len ); }
      inline char * strncpy( char * s1, const char * s2, size_t len )
                     { return __strncpy( s1, s2, len ); }
      inline char * strrchr( const char * s1, int ch )
                     { return __strrchr( s1, ch ); }
#line 105
      void * _Builtin __memcpy( void *, const void *, size_t );
      void * _Builtin __memchr( const void *, int, size_t );
      int    _Builtin __memcmp( const void *, const void *, size_t );
      void * _Builtin __memset( void *, int, size_t );
      void * _Builtin __memmove( void *, const void *, size_t );

      void * _Optlink memcpy( void *, const void *, size_t );
      void * _Optlink memchr( const void *, int, size_t );
      int    _Optlink memcmp( const void *, const void *, size_t );
      void * _Optlink memset( void *, int, size_t );
      void * _Optlink memmove( void *, const void *, size_t );
#line 118
         inline void * memcpy( void * m1, const void * m2, size_t len )
                        { return __memcpy( m1, m2, len ); }
         inline void * memchr( const void * m, int ch, size_t len )
                        { return __memchr( m, ch, len ); }
         inline int    memcmp( const void * m1, const void * m2, size_t len )
                        { return __memcmp( m1, m2, len ); }
         inline void * memset( void * m, int ch, size_t len )
                        { return __memset( m, ch, len ); }
         inline void * memmove( void * m1, const void * m2, size_t len )
                        { return __memmove( m1, m2, len ); }
#line 140
         void * _Optlink memccpy( void *, void *, int, unsigned int );
         int    _Optlink memicmp( void *, void *, unsigned int );

         #pragma info( none )
#line 150
         #pragma info( restore )
#line 158
      char * _Optlink strdup( const char * );
      int    _Optlink stricmp( const char *, const char * );
      char * _Optlink strlwr( char * );
      int    _Optlink strnicmp( const char *, const char *, size_t );
      char * _Optlink strupr( char * );

      int    _Optlink strcmpi( const char *, const char * );
      char * _Optlink strrev( char * );
      char * _Optlink strset( char *, int );
      char * _Optlink strnset( char *, int, size_t );
      char * _Optlink _strerror( char * );
#line 181
      size_t _Optlink _fstrcspn( const char *, const char * );
      char * _Optlink _fstrdup( const char * );
      char * _Optlink _nstrdup( const char * );
      int    _Optlink _fstricmp( const char *, const char * );
      char * _Optlink _fstrlwr( char * );
      int    _Optlink _fstrnicmp( const char *, const char *, size_t );
      char * _Optlink _fstrnset( char *, int, size_t );
      char * _Optlink _fstrpbrk( const char *, const char * );
      char * _Optlink _fstrrev( char * );
      char * _Optlink _fstrset( char *, int );
      size_t _Optlink _fstrspn( const char *, const char * );
      char * _Optlink _fstrstr( const char *, const char * );
      char * _Optlink _fstrtok( char*, const char * );
      char * _Optlink _fstrupr( char * );

      #pragma map( _fstrcspn , "strcspn"  )
      #pragma map( _fstrdup  , "strdup"   )
      #pragma map( _nstrdup  , "strdup"   )
      #pragma map( _fstricmp , "stricmp"  )
      #pragma map( _fstrlwr  , "strlwr"   )
      #pragma map( _fstrnicmp, "strnicmp" )
      #pragma map( _fstrnset , "strnset"  )
      #pragma map( _fstrpbrk , "strpbrk"  )
      #pragma map( _fstrrev  , "strrev"   )
      #pragma map( _fstrset  , "strset"   )
      #pragma map( _fstrspn  , "strspn"   )
      #pragma map( _fstrstr  , "strstr"   )
      #pragma map( _fstrtok  , "strtok"   )
      #pragma map( _fstrupr  , "strupr"   )
#line 214
      }
#line 219
#pragma info( none )

   #pragma info( restore )

#pragma info( restore )
#line 1 "\ibmcpp\include\stdlib.h"
#pragma info( none )

   #pragma info( none )

#pragma info( restore )
#line 11
      extern "C" {
#line 14
   /********************************************************************/
   /*  <stdlib.h> header file                                          */
   /*                                                                  */
   /*  Licensed Materials - Property of IBM                            */
   /*                                                                  */
   /*  IBM C/C++ Tools Version 2.01                                    */
   /*  Copyright (C) International Business Machines Corp., 1991,1993  */
   /*  All rights reserved                                             */
   /*                                                                  */
   /*  US Government Users Restricted Rights -                         */
   /*  Use, duplication, or disclosure restricted                      */
   /*  by GSA ADP Schedule Contract with IBM Corp.                     */
   /*                                                                  */
   /********************************************************************/
#line 36
     typedef unsigned short wchar_t;
#line 39
   typedef struct _div_t
       {
       int quot;        /* quotient of integer division       */
       int rem;         /* remainder of integer division      */
       } div_t;

   typedef struct _ldiv_t
       {
       long int quot;   /* quotient of long integer division  */
       long int rem;    /* remainder of long integer division */
       } ldiv_t;
#line 64
   /* function prototypes */

   int      _Builtin __abs( int );
   long int _Builtin __labs( long int );

   double   _Optlink atof( const char * );
   int      _Optlink atoi( const char * );
   long int _Optlink atol( const char * );
   double   _Optlink strtod( const char *, char ** );
   long int _Optlink strtol( const char *, char **, int );
   unsigned long int _Optlink strtoul( const char *, char **, int );
   int      _Optlink rand( void );
   void     _Optlink srand( unsigned int );
   void *   (_Optlink calloc)( size_t, size_t );
   void     (_Optlink free)( void * );
   void *   (_Optlink malloc)( size_t );
   void *   (_Optlink realloc)( void *, size_t );
   void     _Optlink abort( void );
   int      _Optlink atexit( void ( * )( void ) );
   void     _Optlink exit( int );
   char *   _Optlink getenv( const char * );
   int      _Optlink system( const char * );
   void *   _Optlink bsearch( const void *, const void *, size_t, size_t,
                              int ( * _Optlink __compare )( const void *, const void * ) );
   void     _Optlink qsort( void *, size_t, size_t,
                            int ( * _Optlink __compare )( const void *, const void * ) );
   int      _Optlink abs( int );
   div_t    _Optlink div( int, int );
   long int _Optlink labs( long int );
   ldiv_t   _Optlink ldiv( long int, long int );
   int      _Optlink mblen( const char *, size_t );
   int      _Optlink mbtowc( wchar_t *, const char *, size_t );
   int      _Optlink wctomb( char *, wchar_t );
   size_t   _Optlink mbstowcs( wchar_t *, const char *, size_t );
   size_t   _Optlink wcstombs( char *, const wchar_t *, size_t );
#line 101
      inline int abs ( int x ) { return __abs ( x ); }
      inline int labs( int x ) { return __labs( x ); }
#line 118
         void * _Builtin __alloca( size_t );
         #pragma info( none )
#line 122
         #pragma info( restore )
#line 125
      unsigned char _Builtin __parmdwords( void );

      long double _Optlink _atold( const char * );
      char * _Optlink  ecvt( double, int, int *, int * );
      char * _Optlink _ecvt( double, int, int *, int * );
      char * _Optlink  fcvt( double, int, int *, int * );
      char * _Optlink _fcvt( double, int, int *, int * );
      int    _Optlink _freemod( unsigned long );
      char * _Optlink _fullpath(char *, char *, size_t);
      char * _Optlink  gcvt( double, int, char * );
      char * _Optlink _gcvt( double, int, char * );
      int    (_Optlink _heapmin)( void );
      char * _Optlink  itoa( int, char *, int );
      char * _Optlink _itoa( int, char *, int );
      int    _Optlink _loadmod( char *, unsigned long * );
      char * _Optlink  ltoa( long, char *, int );
      char * _Optlink _ltoa( long, char *, int );
      size_t _Optlink _msize(void *);
      int    _Optlink  putenv( const char * );
      int    _Optlink _putenv( const char * );
      long double _Optlink  strtold( const char *, char ** );
      long double _Optlink _strtold( const char *, char ** );
      char * _Optlink  ultoa( unsigned long, char *, int );
      char * _Optlink _ultoa( unsigned long, char *, int );

      #pragma map( ecvt    , "_ecvt"    )
      #pragma map( fcvt    , "_fcvt"    )
      #pragma map( gcvt    , "_gcvt"    )
      #pragma map( itoa    , "_itoa"    )
      #pragma map( ltoa    , "_ltoa"    )
      #pragma map( ultoa   , "_ultoa"   )
      #pragma map( putenv  , "_putenv"  )
      #pragma map( _strtold, "strtold"  )
#line 182
         int  _Optlink _beginthread( void ( * _Optlink __thread )( void * ), void *, unsigned, void * );
         void _Optlink _endthread( void );
         void ** _Optlink _threadstore( void );
#line 187
      #pragma map( atof  , "_atofieee"   )
      #pragma map( strtod, "_strtodieee" )
#line 192
         void  _Builtin __enable( void );
         void  _Builtin __disable( void );
#line 200
               int * _Optlink _errno( void );
               #pragma info( none )

               #pragma info( restore )
#line 214
               int * _Optlink __doserrno(void);
               #pragma info( none )

               #pragma info( restore )
#line 226
         extern char **_environ;
         extern unsigned char _osmajor;
         extern unsigned char _osminor;
         extern unsigned char _osmode;
#line 236
         typedef int ( __onexit_t )( void );
         typedef __onexit_t * onexit_t;

         /* Sizes for buffers used by the _makepath() and _splitpath() functions.*/
         /* Note that the sizes include space for null terminating character.    */
#line 248
         void          _Optlink _exit( int );
         onexit_t      _Optlink  onexit( onexit_t );
         onexit_t      _Optlink _onexit( onexit_t );
         unsigned int  _Optlink _rotl (unsigned int, int);
         unsigned int  _Optlink _rotr (unsigned int, int);
         unsigned long _Optlink _lrotl(unsigned long, int);
         unsigned long _Optlink _lrotr(unsigned long, int);
         void          _Optlink _makepath( char *, char *, char *, char *, char * );
         void          _Optlink _splitpath( char *, char *, char *, char *, char * );
         void          _Optlink _searchenv( char *, char *, char *);
         void          _Optlink  swab( char *, char *, int );
         void          _Optlink _swab( char *, char *, int );

         #pragma map( onexit , "_onexit"  )
         #pragma map( swab   , "_swab"    )

         /* Define different memory model versions of memory management       */
         /* routines to the standard names.                                   */
#line 295
      }
#line 300
#pragma info( none )

   #pragma info( restore )

#pragma info( restore )
#line 1 "\c2cpp\sample\column.h"
typedef	int	BOOL;
#line 6
void	error_handler(unsigned int errnum, char *message);
int	read_param(char **param, int defolt);
#line 1 "\c2cpp\sample\params.h"
typedef	struct	{
	BOOL		fQuestion;
	BOOL		fTextMode;
	int		iRecLen;
	int		iStartLine;
	int		iEndLine;
}	PARAMS;

void	defaults(PARAMS* pParams);
int	ParamsSetup(PARAMS* pParams, int argc, char** argv);
BOOL	in_range(PARAMS* pParams, int value);
#line 7 "params.c"
/* ---------------------------------------------------------------------
	Set up the default mode, record length etc.
	Default is text mode with maximum line length of 255. Processing
	occurs for all records.
   --------------------------------------------------------------------- */

void	defaults(PARAMS* pParams)
{
	pParams->fQuestion		=	0;
	pParams->fTextMode		=	1;
	pParams->iRecLen			=	255;
	pParams->iStartLine		=	0;
	pParams->iEndLine			=	0;
}

/* ---------------------------------------------------------------------
	Read the command line arguments to determine the record lengths,
	record number range and whether to use text mode.
	TransformSetup does the analysis of how to re-arrange the columns.
   --------------------------------------------------------------------- */

int	ParamsSetup(PARAMS* pParams, int argc, char** argv)
{
	int	i;
	int	iNewRecLen, iMaxCol;
	int	cStart, cEnd, cLength, cNew;
	char	*parm;
	char	chType;

	/*	first determine the new record length after changes */

	iMaxCol = 0;
	iNewRecLen = 0;

	for (i=3; i<argc; i++) {
		parm = strupr(argv[i]);
		switch (*parm++) {
			case 'T'	:
				pParams->fTextMode = 1;
				pParams->iRecLen = read_param(&parm, pParams->iRecLen);
				break;

			case 'F'	:
				pParams->fTextMode = 0;
				pParams->iRecLen = read_param(&parm, pParams->iRecLen);
				break;

			case 'L'	:
				pParams->iStartLine	= read_param(&parm, pParams->iStartLine);
				pParams->iEndLine		= read_param(&parm, pParams->iEndLine);

				if (pParams->iEndLine - pParams->iStartLine < 0)
					error_handler(6, argv[i]);
				break;

			case 'R'	:
				cStart = read_param(&parm, 1);
				cEnd = read_param(&parm, pParams->iRecLen);

				if ((cLength = 1 + cEnd - cStart) <= 0)
					error_handler(6, argv[i]);

				chType = *parm++;
				cNew = read_param(&parm, 1);

				switch (chType) {
					case 'C'	:
						iNewRecLen += cLength;
						iMaxCol = (((iMaxCol) > (cNew + cLength - 1)) ? (iMaxCol) : (cNew + cLength - 1));
						break;

					case 'D'	:
						iNewRecLen -= cLength;
						break;

					case 'Z'	:
					case 'B'	:
					case 'S'	:
						iMaxCol = (((iMaxCol) > (cEnd)) ? (iMaxCol) : (cEnd));
						break;

					case 'M' :
						iMaxCol = (((iMaxCol) > (cNew + cLength - 1)) ? (iMaxCol) : (cNew + cLength - 1));
						break;

					default	:
						error_handler(5, argv[i]);
						break;
				}
				break;

			case 'Q'	:
				pParams->fQuestion = 1;
				break;

			default	:
				error_handler(5, argv[i]);
				break;
		}
	}

	if (pParams->fTextMode)
		pParams->iRecLen += 1;		/* adjust for end of string code */

	iNewRecLen += pParams->iRecLen;
	iNewRecLen = (((iNewRecLen) > (iMaxCol)) ? (iNewRecLen) : (iMaxCol));

	if (pParams->iRecLen != iNewRecLen &&
		(pParams->iStartLine !=0 || pParams->iEndLine != 0) &&
		!pParams->fTextMode)
		error_handler(7, 0);

	return iNewRecLen;
}

/* ---------------------------------------------------------------------
	Check whether a line number is within a set of inclusive bounds.
	Note that if a bound is zero, it does not apply.
	The arguments are:
		pParams	=	specification of which line numbers are allowed.
		value		=	value to test
	Return value is TRUE if within range and FALSE otherwise.
   --------------------------------------------------------------------- */

BOOL	in_range(PARAMS* pParams, int value)
{
	if (pParams->iStartLine	!= 0 && value < pParams->iStartLine)	return 0;
	if (pParams->iEndLine	!= 0 && value > pParams->iEndLine)		return 0;
	return 1;
}
